\chapter{Distributed Thread Synchronization} \label{chapt:barrier}

%
%
\vskip 1cm
%
%

Traditional hardware synchronization mechanisms rely on centralized masters, which incur in poor scalability and do not fit many-core architectures. This Chapter proposes a novel thread synchronization mechanism which relies on a distributed master and on a lightweight control unit to be deployed within the nu+ tile described in Chapter \ref{chapt:core}.

Moreover, this solution does not rely on memory access for exchanging synchronization information since it uses hardware-level messages, which has traditionally been a major bottleneck for such solutions.

Furthermore, the presented solution supports multiple barriers for different application kernels possibly being executed simultaneously, desirable feature in modern many-core systems.
%The results for different NoC sizes provide indications about the reduced synchronization times and the area overheads incurred by our solution.


\section{Motivations}
The increasing need for resource- and power-efficient computing over the last decade has stimulated the emergence of compute platforms with moderate or high levels of parallelism, such as GPU, SIMD, and many-core processors in a variety of application domains~\cite{paranjape2010heterogeneous}. 

In particular, many-core systems are based on a considerable number of lightweight processor cores typically connected through a Network-on-Chip (NoC)~\cite{bjerregaard2006survey,survey16-ref}, providing a scalable approach to the interconnection of parallel on-chip systems. In fact, on-chip connectivity has been attracting much interest during the last years, also including recent developments at the physical technology level~\cite{CAS16-ref,fusella2017h}.

While early NoCs, like the Epiphany mesh-based interconnect~\cite{olofsson2016epiphany}, used a flat cache-less memory model, caching and related coherence management has become a crucial feature in today's NoCs needed to improve performance and preserve programmability in many-core systems.

Examples of modern many-core solutions include an integrated 80-tile NoC prototype architecture, based on an on-chip 2D mesh topology, proposed by Intel~\cite{vangal200780}, and the Tilera TILE64 processor~\cite{wentzlaff2007chip}, based on three-wide VLIW compute cores with 64-bit instruction words as well as a scalable 2D mesh network with support for coherent shared memory, where each core can directly access any other cache through the interconnect. The Tilera NoC infrastructure in fact provides five different networks for different uses, including one dedicated to memory transactions.

Being targeted at parallel applications, these systems are expected to provide some form of support for thread synchronization, e.g. {\em barrier} primitives. Existing solutions use a variety of hardware- or software-based techniques. The work in~\cite{hoefler2004survey} describes some synchronization algorithms implemented in software, that rely on a message passing infrastructure and different NoC topologies. In~\cite{abellan2012efficient} the authors implemented a dedicated G-line net dedicated to barriers. This solution is limited to ASIC architectures and requires a wire for each tile. In~\cite{monchiero2006efficient}, the authors support thread synchronization in a packet-switched manycore NoC by relying on two types of links.

%This Chapter presents an activity developed in the context of the {\em MANGO: exploring Manycore Architectures for Next-GeneratiOn HPC systems} H2020 research project. As part of the manycore architecture exploration carried out by the project, the authors developed a customizable GPU-like core used as the compute element in a configurable NoC with support for coherent shared memory. The manycore system is tested on a large-scale FPGA platform developed by MANGO, where hardware reconfigurability is mostly used for emulation purposes, although FPGAs could also be chosen as the final acceleration technology for certain classes of workloads~\cite{FPL13-ref,DATE14-ref}.
%
This chapter specifically explores the adoption of a distributed and NoC-based synchronization mechanisms. At the heart of the proposed approach is a distributed synchronization master inspired by the directory-based coherence scheme. Relying on the distributed approach as well as the lightweight three-staged synchronization client on the core side, the proposed architecture can support multiple synchronizations for different application kernels running concurrently. The remainder of the Chapter describes the main insights in this approach, the resulting architecture and the way it handles multiple synchronizations concurrently, as well as the advantages of the distributed mechanism.

The rest of the chapter is organized as follows. Section~\ref{bar:related-sec} summarizes previous techniques for supporting barrier synchronization in manycore architectures.
Section~\ref{bar:architecture-sec} describes the baseline manycore system as well as the synchronization hardware introduced by this work. Section~\ref{bar:implementation-sec} describes the implementation of the barrier function, while in section~\ref{bar:evaluation-sec} it is evaluated with a synthetic benchmark both in a central and distributed configuration for different NoC sizes.

\section{Related Works} \label{bar:related-sec}

Barrier synchronization is a common primitive used to separate in time different phases of a parallel application. Efficient support for barrier synchronization in manycore systems is of paramount importance because of its role in parallel code.

Culler and Gupta in~\cite{culler1999parallel} address this problem for shared-memory multiprocessors. They present a software solution, which relies on hardware atomic instructions and memory coherence. The solution uses a lock variable and a counter keeping track of all the cores that have hit the synchronization point.

Indeed, the literature offers various software-based barrier solutions.
Hoefler and Rehm~\cite{hoefler2004survey} present a study on software barrier algorithms combining both shared memory and message passing techniques.
The authors implement typical barrier synchronization algorithms, such as Butterfly and Combining tree, and analyze message overheads and the required memory for each of them.

The results in~\cite{villa2008efficiency} show that software barriers, even when based on hardware message passing, incur considerable overheads
causing NoC resources to stay underutilized, unlike hardware barriers. As a consequence, many NoC-based techniques have been proposed in the last years.
%
%In~\cite{barrier:goodman}, authors propose an hardware barrier mechanism based on dedicated wires called G-line presented on a NoC-based system. Every G-line is a wire that enables the transmission of 1 bit of information across one dimension of the chip in a single clock cycle and a master which collects all signals from the slaves.
%
In~\cite{abellan2012efficient}, the authors implement a hard-wired barrier mechanism called G-line net.
Each core has a dedicated wire connected to the barrier master.
Synchronization is established as soon as each core asserts its line.
This technique uses multidrop connectivity and the S-CSMA collision detection in order to provide a flow control mechanism (EVC),
enhancing performance in terms of latency and power consumption.
Such a solution does not require memory accesses, and provides fast synchronization compared to software solutions.
However, the approach may lack scalability and supports only one barrier at a time.

The authors of~\cite{tseng2016scalable} propose a communication unit in a NoC-based system,
relying on a barrier controller and a communication unit that enable synchronization operations.
The control unit is integrated into a general NoC switch and communicates with a centralized master located in the network.
The paper proposes an efficient control mechanism, but it still relies on a centralized master resulting in limited scalability.
%
Similarly, \cite{zhu2007synchronization}~introduces a synchronization architecture, called the Synchronization State Buffer (SSB),
which is a small buffer attached to the memory controller of each memory bank.
It records and manages the states of active synchronized data units to support and accelerate word-level fine-grain synchronization.
The SSB solution has been implemented in the context of the $160$-core IBM Cyclops-64 chip architecture. 

The authors of~\cite{monchiero2006efficient} propose a novel thread synchronization technique relying on packet-switching mechanisms in a NoC-based manycore system.
The interconnection system provides two physical links used in the protocol in order to avoid deadlocks.
The work introduces a synchronization-operation buffer (SB), which enqueues and manages the requests issued by the processors.
The mechanism uses a spin lock implementation, requiring a constant number of network transactions and memory accesses per lock acquisition.
%
Note that the approaches described above do not support concurrent barriers if different application kernels are running in separate sub-regions of the manycore system.

%Volendo posso fare un approfondimento suo relative work andando a considerare approccio software e approccio Hardware e riorganizzando questo paragrafo così:
%Approccio software basato sull'uso delle istruzioni atomiche  LL SC, Mutex o Scambio di messaggi. Attraverso l'uso di queste primitive possiamo avere differenti algoritmi di Barrier, Centralizzato, Butterfly e disseminazione.. Qui si va a mettere lo studio di Hoefler and Rehm già messo sopra
%
%Approccio Hardware:
%			Memory Based : usano il bit full/empty in memoria, da rivedere : R. Alverson et al. The Tera Computer System. In Proceedings of 4th Inter- national Conference on Supercomputing
%			Network Based : Prevede l'uso di una Virtual Channel, HSu e Yew  propongono una rete ”multistage shuffle-exchange network” per gestire in maniera efficiente il traffico dei pacchetti di sincronizzazione software
%			Gobal line: GBarrier Presentata sopra
%			Special Purpose: Beckmann e Polychronopoulos, presenta uno schema hardware specificamente progettato per la Barrier Synchronization, da approfondire

\begin{figure}[t]
	\centering
	\includegraphics[width=0.6\linewidth]{Chapters/HwBarriers/images/manycore64}
	\caption{Typical many-core mesh-based with 64 tiles}
	\label{fig:manycore64}
\end{figure}

\section{Centralized solution vs distributed synchronization master}
In this section is discussed the potentially of a ``distributed'' approach over a standard ``centralized'' solution. Let consider a generic many-core system composed by 64 tiles, each equipped with a multi-threated processing element, for a total of $256$ threads in the system. The tiles communicate through hardware messages flowing over a 2D mesh on-chip network, as shown in Figure \ref{fig:manycore64}.
Let analyze and understand the load of the synchronization mechanism over the network of such a configuration.

%For the hypothesis of the analysis there are only synchronization messages in the NoC.
At the software layer, the user runs a parallel application which uniformly spreads its elaboration over $256$ hardware threads divided in $4$ groups. Each thread performs its computation and then synchronizes with the others within its group, in order to build the partial result. A second level of synchronization is required to synchronize all the thread groups, in order to produce the final result. Figure~\ref{fig:executionexample} shows the execution flow and highlights the synchronization points. When a thread hits a barrier point, a synchronization transaction starts, where the thread first sends a hardware message to the synchronization master over the network, then blocks its execution until an explicit release from the master arrives.

\begin{figure}[t]
	\centering
	\includegraphics[width=0.85\linewidth]{Chapters/HwBarriers/images/ExecutionExample}
	\caption{Simplified execution flow and synchronization points.}
	\label{fig:executionexample}
\end{figure}

%In this execution between the steps there is the synchronization barrier for ensuring the sequential ordering between the different parallel execution flows.
%In the first step, the user has to insert 4 independent barrier with 64 threads for each. In the second step there is an independent synchronization between the 4 execution threads.
%An example code for this kernel is show below in Figure 
%In the manycore the developer has to manage the data and the organization of the thread in the architecture for optimize the execution of the algorithm. For this reason the best way is to run the 256 thread in 4 groups as highlight in Figure \ref{fig:manycore64}. For the synchronization barrier instruction, with centralized master approach the user can choose the id independently because the same synchronization core execute all barrier threads, but for optimized the performance must connect the synchronization core module in the centre of the  manycore, tile 27, 28,35,36. In case of distributed master approach there is a small instance of synchronization core in each tile and each synchronization core manages a small range of barrier id. For this reason the user in this case has to select the correct id of barrier for optimizing his execution. In the application upon in the first 4 synchronization the user has to choose the Id managed by the tile 18, 21, 45 and 42 each per different synchronization. For the second step one between the tile 27,28,35 and 36.
In a standard centralized synchronization mechanism, the system would have a single synchronization master, most-likely placed in a tile near the center of the mesh in order to minimize the average number of hops (where passing a router counts as one hop) required for a synchronization message to reach the master. In the worst possible case, the threads will hit the synchronization point at the same time, starting $256$ concurrent transactions. Their messages flow to the master which could be busy dealing with another synchronization, or such messages could be delayed due the congestion in routers around the master. This leads to a major bottleneck: a single synchronization master congests the network slowing down the overall execution time. Furthermore, a centralized master ought to keep track of ongoing synchronization transaction memorizing information in local hardware structures and local memories. The more the cores are the bigger such structures would be, resulting in a poor scaling up for a growing number of cores. 

On the other hand, such architectures would benefit of a distributed synchronization master where each tile could be elected as synchronization master. In the above scenario, each thread group elects the most appropriate tile independently, most-likely inside the synchronization group, resulting in a better networking balance and a lower delay in message exchanging. Furthermore, a distributed master spreads its resources, such as local buffers, over all the tiles, helping the system in scaling up with the number of cores.

Next, these two scenarios are compared in term of average hops count over the network-on-chip required for a synchronization transaction for each barrier, using the above example where $256$ synchronization transactions are issued concurrently.

\begin{table}[t]
	\centering
	%
	% Follow this input for your own table layout
	%
	\begin{tabular}{p{2.6cm}p{2.4cm}p{2cm}}
		\hline\noalign{\smallskip}
		\textbf{Metrics Size} & \textbf{Centralized} & \textbf{Distributed}\\ \hline
		%	\noalign{\smallskip}\svhline\noalign{\smallskip}
		HC barr. 1 & 240  & 160\\
		HC barr. 2 & 320 & 160\\
		HC barr. 3 & 320  & 160\\
		HC barr. 4 &  400 & 160\\
		Avg. HC & 320  & 160\\
		Max. HC & 8  & 4\\
		Max num. Req & 64  & 16\\
		%	8x8 & mRNA  & 24--2\\
		\noalign{\smallskip}\hline\noalign{\smallskip}
	\end{tabular}
	\\ HC in the table stands for ``Hop Counts''.
	\caption{Differences in hops count between a centralized master synchronization and a distributed counterpart.}
	\label{tab:hoptable}       % Give a unique label
\end{table}

Table~\ref{tab:hoptable} shows the hops count (in average) over the network in both the centralized and the distributed approaches. As expected, the different loads over the network is evident: the central approach counts the doubles of number of hops needed in the average compared to its distributed counterpart. %Moreover, the table does not highlight that the centralized approach all request are managed by a single master, so nearest the central Tile it is generated a hotspot and a bottleneck for the NoC. In this example in the Distributed approach the message are correctly balanced along the NoC and for each Synchronization core there are at maximum 64 requests in parallel. %Otherwise, in the Centralized approach there are 256 requests in parallel.

\section{Architecture} \label{bar:architecture-sec}
%
%\begin{figure}[t]
%	\centering
%	\includegraphics[width=0.80\linewidth]{Chapters/HwBarriers/images/nuplus_manycore1}
%	\caption{The custom manycore system addressed by this work.}
%	\label{fig:nuplus_manycorecopia}
%\end{figure}
%
The proposed synchronization mechanism has been integrated in the baseline many-core system presented in chapters \ref{chapt:core} and \ref{chapt:coherence}. %The GPU-like core comes with a parametrized NoC-based manycore architecture, as shown in Figure~\ref{fig:manycore}, where each tile includes a hardware multi-threaded SIMD processor. As described in chapter \ref{chapt:coherence}, the many-core system supports a distributed coherent L2 cache and hardware coherence support based on a directory-based protocol.

The main idea behind the proposed solution is to provide a distributed approach inspired by such a directory-based system. The architecture aims to eliminate centralized synchronization masters, resulting in a better message balancing across the network with the constraint that the synchronization architecture needs to be parametrized in the number of parallel barriers that we can have at same time.
%In other, for supporting to model language as openMP, we need to support the nested barrier and we can reuse a same id in more point of a Kernel. %[Commented, not clear at alls]
Combining a distributed approach, hardware-level messages, and a fine-grain control, the solution supports multiple barriers simultaneously from different core subsets. 
This is often required by modern application programming interfaces, such as openMP, that support multi-platform shared memory multiprocessing programming. %[Added by Mirko]
Coherence does not affect the overall performance, since the system provides a dedicated virtual network exclusively used for synchronization.

The remainder of this section describes the main components of the proposed synchronization hardware and how it has been integrated into the baseline many-core system.
%previous version
%\noindent\emph{Boot Setup}. 
%%
%The Boot Setup module is in charge of initializing every structure involved in a barrier synchronization.
%It sends the \texttt{Setup} messages in the initialization phase, then sets and updates the barrier counters in the %involved Synchronization Core.
%%
%When an application kernel requires a synchronization, it specifies the barrier ID and the number of cores involved.
%The Boot Setup module steps into the Service state where it gathers all this information and selects a %synchronization master.
%Then, when the network is ready, the Boot Setup initializes the chosen Synchronization Core by sending suitable %messages through the NoC,
%conveying the barrier ID and the number of cores involved.
%From this point onward, the designated Synchronization Core becomes the synchronization master of this barrier,
%and it will handle all the synchronization messages from the involved cores.

\subsection{Barrier Core}
%
The \texttt{Barrier Core} manages the synchronization on the core side, and each core in each tile is equipped with one of this module. Each thread in a processing core can issue a barrier request through a specific barrier instruction introduced into the processor ISA.
When this happens (from now onward we will refer to this event as a thread hitting a barrier or a synchronization point), the Barrier Core sends an \texttt{Account} message to the Synchronization Core, and stalls the requesting thread until a \texttt{Release} message from the master arrives.
The synchronization master sends a \texttt{Release} per core even if more threads are stalled on the same synchronization point. The synchronization master has no information about stalled threads, which is left to the Barrier Core inside the GPU-like core. When a core receives a \texttt{Release} message, its Barrier Core module checks which threads are stalled on that specific barrier and releases all of them. 

The mechanism described above in hardware is implemented through the FSM in Figure \ref{fig:BarrierCoreV}. The Barrier has to ensure that all instruction before are committed and all data are written in memory. When, the instruction barrier synchronization is executed from the hardware thread the Barrier Core goes in the \texttt{Check Core} state. This state is essential for ensuring that all instructions already scheduled have been committed,  it blocks the following instruction when a barrier is issued, and prepares to send the \texttt{Account} message as soon as all previous instructions are committed. When this happens, the Barrier Core transits into the \texttt{Send Account} state. Here the Barrier Core acquires the channel and sends the message to relative Synchronization core, turning into the \texttt{Wait Release} state until the \texttt{Release} message is received which closes the barrier and resumes the normal execution. %Inside the Barrier core the Release message means that all other attendees have reached the synchronization point. 

\begin{figure}[t]
	\centering
	\includegraphics[width=0.90\linewidth]{Chapters/HwBarriers/images/MSBarrier}
	\caption{FSM of Barrier Core.}
	\label{fig:BarrierCoreV}
\end{figure}


\subsection{Synchronization Core}
%
The \texttt{Synchronization Core} is the key component of the proposed solution. This module acts as the synchronization master, but unlike other hardware synchronization architectures, it is distributed all over the tiles in the manycore system. As explained above, the Barrier Core module selects a specific Synchronization Core based on the barrier ID set by the first message of barrier. In this way, the architecture spreads synchronization messages all over the manycore. By using this approach, the synchronization master is no longer a network congestion point.
%In the hypothesis of the execution of the barrier synchronization the user know the exact number of treads attendees at the synchronization Barrier, hence 
In this solution is programmer's duty selecting an ID and the exact numbers of synchronizing threads for each barrier. The first message is responsible for the setup, physically this mechanism is implemented in the Synchronization core. Figure~\ref{fig:BarrierCorecopia} shows a simplified view of the Synchronization Core.

\begin{figure}[t]
	\centering
	\includegraphics[width=0.9\linewidth]{Chapters/HwBarriers/images/BarrierCore}
	\caption{Overview of the Synchronization Core.}
	\label{fig:BarrierCorecopia}
\end{figure}
%

The module is made of three stages: the first stage selects and schedules the \texttt{Account} requests, it ensures the atomicity of the barrier operation for the updating of the counter in the stage 2. The selected request steps into the second stage, which strips the control information from the message. In the last stage, the stripped request is finally processed. The first \texttt{Account} request received initializes the barrier structures, namely it sets a counter with the number of involved threads. 
%because the first request must initialize the counter of barrier with number of thread that take part to synchronization. 
%Furthermore counter value is equal to number of threads that take part to synchronization less one, because in the first message we have an optimization with merging of counter setup  and the update of it, which should be execute in two different stage.   
On the other hand, if the request is an \texttt{Account} message on a barrier already initialized, the counter is decremented by $1$. When the counter hits $0$, all the involved cores have reached the synchronization point, and the master sends a multicast \texttt{Release} message to all involved cores. Refer to Figure~\ref{fig:pacchetti} for the format of the synchronization messages.

\begin{figure}[t]
	\centering
	\includegraphics[width=0.8	\linewidth]{Chapters/HwBarriers/images/pacchetti}
	\caption{
		Synchronization messages, 64 bits each.
		The \texttt{Account} message is sent to the master, when a thread hits the barrier from the core side.
		The \texttt{Release} message is sent by the synchronization master to all the involved cores when all the \texttt{Account} messages are collected. }
	\label{fig:pacchetti}
\end{figure}

%\smallskip
%\noindent\emph{Barrier Core}.
%%
%The Barrier Core manages the synchronization on the core side. Each thread in a processing core can issue a barrier request
%through a specific barrier instruction introduced into the processor ISA.
%When a thread hits the synchronization point, the Barrier Core sends an \texttt{Account} message to the Synchronization Core,
%and stalls the requesting thread until a \texttt{Release} message from the master arrives.


\subsection{An example of synchronization}
%
Let consider a many-core system featuring $8$ processing tiles, as shown in Figure \ref{fig:example}. A parallel kernel is executed, which involves all tiles and $2$ threads per tile. On the kernel side, two groups of threads are working on different data. The first group (from now onward referred to as \texttt{group\_0}) is composed by $4$ tiles with ID $0$, $1$, $2$, and $3$. Dually, the second group (\texttt{group\_1}) is composed of the remaining tiles, namely $4$, $5$, $6$, and $7$. After a computational phase, each group requires its own synchronization point, and each group has a total of $8$ threads to synchronize. Barrier IDs are chosen by the developer and encoded in the GPU-like core barrier instructions. Each group has an exclusive barrier ID which helps the architecture handle concurrent synchronizations.

When a thread hits the synchronization point, it stalls its execution, waits for all previous instructions to commit, and the Barrier Core in its tile sends an \texttt{Account} message to the elected synchronization master. Each tile is also equipped with a Synchronization Core module which could be a synchronization master. In this example, cores elect their master in tile $T$ using a simple module operation on ID values: $T = ID \bmod TileNumber$, but any election mechanisms can be used. In this example, \texttt{group\_0} targets as synchronization master tile $T\_3$, dually \texttt{group\_1} elects tile $T\_5$ as master. 

When a Synchronization Core receives the first \texttt{Account} message, it registers the barrier ID and initializes the associated counter to the value of the expected threads. Further, \texttt{Account} messages with the same barrier ID to the master decrement the counter by $1$. When this counter hits $0$, all involved cores are at the synchronization point, and the master sends to each of them a \texttt{Release} message by multicast.

When the \texttt{Release} message arrives, the Barrier Core releases all involved threads and resumes their execution flows. Figure \ref{fig:example} highlights the messages exchanged by all the involved tiles and depicts the time-line of this example. 

\begin{figure}
	\centering
	\includegraphics[width=0.7\linewidth]{Chapters/HwBarriers/images/example}
	\caption{Example of barrier synchronization}
	\label{fig:example}
\end{figure}
 
\section{Implementation} \label{sec:impl} \label{bar:implementation-sec}
%
The core back-end and the front-end have been extended in order to provide a C-level support to such a synchronization. On the back-end side, the processor ISA has been extended with ad-hoc instructions (so called \texttt{barrier}).
On the front-end side, an intrinsic operation has been added, called \texttt{\_\_builtin\_nuplus\_barrier(Id\_Barrier, Counter - 1)}.
%
The synchronization components rely on a private virtual channel added in the networking system, which routes all synchronization messages. The baseline many-core system already provided virtual channels but, as observed above, the hardware coherence support tends to flood the network infrastructure with data and coherence messages, and could easily impact the synchronization mechanism performance.

Furthermore, each Synchronization Core handles a fixed range of barriers, and for this implementation the following the Equation \ref{sys1} expresses the relationship between the numbers of threads in the many-core system and the maximum numbers of barriers concurrently live in the whole architecture:

\begin{equation}\label{sys1}
\centering Barrier_{Max} = K_{const}\times(Tile_{Max} \times Thread_{perTile}) 
\end{equation}

Equation \ref{sys1} states that $ Barrier_{Max}$ (maximum number of barriers concurrently live in the many-core), increases with the global number of threads in the system. Importantly, $K_{const}$ changes with the type of benchmark, as it increases with the number of synchronization operations.
In the current implementation, both $K_{const}$ and $Thread_{perTile}$ are tied to $4$, so that each Synchronization Core handles $16$ barrier simultaneously.

On the core side, when a barrier instruction is decoded, the control unit waits until all previous instructions are committed (in the Writeback stage), then it stalls the requesting thread, and fetches the barrier into the Barrier Core module in the execution stage.
This component sends an \texttt{Account} message to the designated Synchronization Core, and waits until a \texttt{Release} message arrives.
%
%\begin{figure}[t]
%	\centering
%	\includegraphics[%angle=90, 
%	width=0.7\linewidth]{Chapters/HwBarriers/images/nuplus_core}
%	\caption{The microarchitecture of the GPU-like core and the Barrier functional unit.}
%	\label{fig:nuplus_core}
%\end{figure}
%
%We integrated the Boot Setup component in the Host Interface tile, which is normally used for communication and for booting the manycore system.
%An arbiter selects the proper component in the Host Interface tile depending on the commands coming in through the interface.
%
The Synchronization Core has been integrated at the tile level. It is connected to the network interface (NI) of the processor tile and dispatches messages on the synchronization virtual channel. % In the next section, we will compare the performance of our distributed solution with a centralized master approach that allocates the Synchronization Core only in Tile $0$.

\section{Evaluation} \label{bar:evaluation-sec}
In this section, the performance of the proposed solution are evaluated in terms of clock cycles and area overhead. Next, the presented solution is compared with a standard synchronization mechanism based on a centralized master. The distributed solution will not be compare with any software approach~\cite{monchiero2006efficient}, since this work does not require memory accesses or atomic instructions, and thus incurs a significantly lower latency. 
%
A major feature introduced by the proposed solution is the support for multiple barrier synchronizations from different application kernels being executed simultaneously on different subsets of cores.

\begin{table}[!ht]
	\centering
	\resizebox{0.7\columnwidth}{!}{
		\begin{tabular}{cccc}
			\multicolumn{4}{c}{\textbf{Barrier Core}}                                             \\[0.1cm] \hline
			\multicolumn{1}{c||}{\textbf{NoC (size)}}    & \textbf{LUT} & \textbf{Flip-Flop} & \textbf{BRAM} \\[0.1cm] \hline
			\multicolumn{1}{c||}{\textbf{2x2}} & 60           & 64           & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{4x2}} & 62           & 72           & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{4x4}} & 68           & 80           & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{8x4}} & 68           & 88           & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{8x8}} & 74           & 96           & 0             \\[0.1cm] \hline \hline\\
			\multicolumn{4}{c}{\textbf{Centralized Synchronization Core }}                                             \\[0.1cm] \hline
			\multicolumn{1}{c||}{\textbf{NoC (size)}}    & \textbf{LUT} & \textbf{Flip-Flop} & \textbf{BRAM} \\[0.1cm] \hline
			\multicolumn{1}{c||}{\textbf{2x2}} & 216           & 337                 & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{4x2}} & 335           & 478                 & 1             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{4x4}} & 545           & 736                 & 1             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{8x4}} & 1210           & 1210                 & 2             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{8x8}} & 1730           & 2124                 & 5             \\[0.1cm] \hline \hline\\
			\multicolumn{4}{c}{\textbf{Distributed Synchronization Core }(per Tile)}                                             \\[0.1cm] \hline
			\multicolumn{1}{c||}{\textbf{NoC (size)}}    & \textbf{LUT} & \textbf{Flip-Flop} & \textbf{BRAM} \\[0.1cm] \hline
			\multicolumn{1}{c||}{\textbf{2x2}} & 148           & 140           & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{4x2}} & 191           & 179           & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{4x4}} & 241           & 519                 & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{8x4}} & 347           & 754                 & 0             \\[0.1cm]
			\multicolumn{1}{c||}{\textbf{8x8}} & 459           & 1100                & 3             \\[0.1cm]
			\hline\hline
		\end{tabular}
	}
	\caption{Comparison of the resource requirements between the distributed and centralized approaches}
	\label{tab:evalarea1-bar}
\end{table}

\subsection{Simulation}
For timing evaluation, the system has been evaluate for different NoC sizes by using a cycle-accurate simulator. Instructions and data memory misses can heavily affect the performance measurement due to their overheads. In order to obtain a qualitative measurement of the synchronization mechanism, all instructions and data are preloaded in the cache memories of all the cores.

The architecture has been successfully synthesized on a Xilinx Virtex-7 xc7v2000tflg1925-1 FPGA both with a standard centralized configuration and with our distributed approach.
Table~\ref{tab:evalarea1-bar} summarizes the resource requirements of the two approaches for different NoC sizes.
The area per tile occupied by the Barrier Core tends to be constant. This module is not influenced by the NoC parameters such as the number of tiles or specific topologies.
%
%On the other hand, in the centralized approach, the Synchronization Core area increases with the number of tiles.
%
The distributed approach incurs area costs increasing with the number of tiles, although it can support a larger number of barriers, which can involve selected sub-groups of threads, with a resource overhead distributed uniformly across the tiles.

The proposed architecture and the centralized solution are simulated in the same environment with the same parameters.
Both run the same kernel made of a sequence of calls to the synchronization intrinsic provided by the compiler, as explained in Section~\ref{sec:impl}. The time performance is evaluated by averaging out the synchronization times of all the involved threads. Each core has been equipped with a $64$-bit performance counter which is initialized when it detects a barrier operation, and stopped when the release message from the master is received.

\begin{table}[t]
	\centering
	\resizebox{0.7\columnwidth}{!}{
		\begin{tabular}{p{2cm}p{2.4cm}p{2cm}}
			\hline\noalign{\smallskip}
			NoC Size & Centralized & Distributed\\\hline
			%)		\noalign{\smallskip}\svhline\noalign{\smallskip}
			2x2 & 34  & 34\\
			4x2 & 47 & 45\\
			4x4 & 79  & 81\\
			8x4 & 150  & 153\\		
			%	8x8 & mRNA  & 24--2\\
			\noalign{\smallskip}\hline\noalign{\smallskip}
		\end{tabular}
	}
	\\ Average clock cycles per thread
	\caption{Time of a single synchronization operation involving all cores}
	\label{tab:evalRimeCase1-bar}       % Give a unique label
\end{table}

\paragraph{Synchronization of the whole manycore system:}
The first experiment runs a kernel which involves all processing cores instantiated in the many-core, comparing the approach based on a centralized synchronization master with our distributed solution. Table \ref{tab:evalRimeCase1-bar} summarizes the clock cycles required by the synchronization for different NoC sizes.
As observed, the two approaches reach the same results, due the limited size of the network and the absence of concurrent synchronizations. Changing the position of the synchronization master does not affect performance.

\paragraph{Synchronization with concurrent kernels:}
The proposed architecture supports multiple barrier synchronizations from different application kernels being executed simultaneously on different subsets of cores. The maximum number of distinct barriers supported is $N/2$, where $N$ is the number of threads instantiated in the system. The second experiment compares the number of clock cycles needed to synchronize all the subsets, running the maximum number of supported barriers in parallel, assuming that the developer parallelizes the kernel on sets of consecutive tiles. 

Table~\ref{tab:evalRimeCase2-bar} summarizes the results of this study. The centralized solution lacks scalability, even for small NoC configurations, and the final count is highly dependent on the position of the synchronization master. On the other hand, the distributed approach requires the same clock count for the smallest NoC, but results in improved scalability as the NoC size is increased. Furthermore, the proposed solution does not rely on a fixed master, as this is chosen based on the barrier ID, hence by the user or possibly by the compiler.

\begin{table}[t]
	\centering
	\resizebox{0.7\columnwidth}{!}{
	\begin{tabular}{p{2cm}p{2.4cm}p{2cm}}
		\hline\noalign{\smallskip}
		NoC Size & Centralized & Distributed\\ \hline
	%	\noalign{\smallskip}\svhline\noalign{\smallskip}
		2x2 & 34  & 34\\
		4x2 & 35 & 32\\
		4x4 & 37.8  & 30\\
		8x4 & 46.1  & 30\\
		%	8x8 & mRNA  & 24--2\\
		\noalign{\smallskip}\hline\noalign{\smallskip}
	\end{tabular}
	}
	\\ Average clock cycles per thread
	\caption{Time of multiple independent synchronization operations taking place concurrently.}
	\label{tab:evalRimeCase2-bar}
\end{table}


\section{Conclusions} \label{bar:conclusions-sec}
%
This Chapter presents a novel distributed synchronization mechanism based on hardware successfully integrated into the baseline custom many-core described in Chapters \ref{chapt:core} and \ref{chapt:coherence}, proving its flexibility and its suitability for hardware exploration.

The novel solution proposed in this Chapter relies on a distributed master and on a lightweight control unit on the core side, providing a synchronization mechanism through hardware-level message exchange without any memory access overhead. Moreover, this solution supports multiple barriers for different application kernels executed simultaneously on different subsets of cores. The results collected for different NoC sizes provided indications about the area overheads incurred by our solution and demonstrated the benefits of using a dedicated hardware synchronization support. Moreover, such mechanisms are fundamental when dealing with non-coherent memories on many-core system, focus of the next Chapter.
%As a long-term goal of this research, we aim to explore the implications of different NoC topologies as well as the impact of the positions of concurrent masters when multiple kernels are run in different subsets of cores.